-- the code works, but it makes just a lot of stam in the factorio-current.log

local new_line = string.char(10) -- new line!

function small_serpent (tabl)
  local str = new_line .. '  {' .. new_line
  for i, v in pairs (tabl) do
    local index = (type(i) == "string") and ('["'..i..'"]') or ('['..i..']')
    str = str .. '    ' .. index .. ' = ' .. serpent.line(v) .. ',' .. new_line
  end
  str = str .. '  }'
  return str
end

function is_value_in_list (value, list)
  for i, v in pairs (list) do if (v == value) then return true end end return false
end

function add_value_to_list_nd (value, list) -- no doubles
  if not is_value_in_list (value, list) then
    table.insert (list, value)
  end
end


local recipes_for_items = {} -- checking if some items can be made with more than only one way


function add_recipes_amount_for_item (item_name)
  if not recipes_for_items[item_name] then
    recipes_for_items[item_name] = 1
  else
    recipes_for_items[item_name] = recipes_for_items[item_name] + 1
  end
end

local all_items_list = {}

local recipe_prerequisits = {}

local enabled_recipes_list = {}
local disabled_recipes_list = {}

for recipe_name, recipe in pairs (data.raw.recipe) do
  local handlers = recipe.normal and {recipe.normal} or {recipe} -- no expensive
  for i, handler in pairs (handlers) do
  
    local recipe_enabled = (handler.enabled == nil) or handler.enabled
    if recipe_enabled then
      -- code for exception; we don't need to check technologies for enabled recipes
      
    end
    
    
    if handler.result then
      local item_name = handler.result
      add_value_to_list_nd (item_name, all_items_list)
      add_recipes_amount_for_item (item_name)
    elseif handler.results then
      for j, result in pairs (handler.results) do
        local typ = result.type or "item"
        local item_name = result.name or result[1]
        if typ == "item" then
          add_value_to_list_nd (item_name, all_items_list)
          add_recipes_amount_for_item (item_name)
        end
      end
    end
  end
end

local double_recipes_for_items = {}
for item_name, recipe_amounts in pairs (recipes_for_items) do
  if recipe_amounts > 1 then
    table.insert (double_recipes_for_items, item_name)
  end
end

log ('all_items_list [' .. #all_items_list .. ']: ' .. serpent.line (all_items_list))
log ('double_recipes_for_items [' .. #double_recipes_for_items .. ']: ' .. serpent.line (double_recipes_for_items))
log ('recipes_for_items [' .. table_size(recipes_for_items) .. ']: ' .. serpent.block (recipes_for_items))


-- all types
local all_types = {}
for type_name, type_prot in pairs (data.raw) do
  for i, item_name in pairs (all_items_list) do
    if type_prot[item_name] then
      add_value_to_list_nd (type_name, all_types)
    end
  end
end

-- log ('all_types [' .. #all_types .. ']: ' .. serpent.line (all_types))


-- hardcoded item_types: 
local all_item_types = {"ammo", "armor", "gun", "item", "capsule", "repair-tool", "tool", "item-with-entity-data", "item-subgroup", "rail-planner", "module", "night-vision-equipment", "energy-shield-equipment", "battery-equipment", "solar-panel-equipment", "generator-equipment", "active-defense-equipment", "movement-bonus-equipment", "roboport-equipment", "belt-immunity-equipment"}

-- hardcoded entity_types: 
local all_entity_types = {"furnace", "transport-belt", "boiler", "container", "electric-pole", "generator", "offshore-pump", "inserter", "pipe", "radar", "lamp", "pipe-to-ground", "assembling-machine", "wall", "lab", "splitter", "underground-belt", "loader", "car", "roboport", "logistic-container", "construction-robot", "gate", "electric-energy-interface", "mining-drill", "resource", "ammo-turret", "solar-panel", "locomotive", "cargo-wagon", "fluid-wagon", "artillery-wagon", "land-mine", "train-stop", "rail-signal", "rail-chain-signal", "logistic-robot", "rocket-silo", "storage-tank", "pump", "accumulator", "beacon", "arithmetic-combinator", "decider-combinator", "constant-combinator", "power-switch", "programmable-speaker", "reactor", "heat-pipe", "burner-generator", "artillery-turret", "electric-turret", "fluid-turret"}


local recipes_with_techs = {}
local techs_open_recipes = {}

local tech_links = {}

for tech_name, tech in pairs (data.raw.technology) do
  if tech.prerequisites then
    for i, prer_name in pairs (tech.prerequisites) do
      if not tech_links[tech_name] then 
        tech_links[tech_name] = {uses = {prer_name}}
      else
        if not tech_links[tech_name].uses then tech_links[tech_name].uses = {} end
        table.insert (tech_links[tech_name].uses, prer_name)
      end
      
      if not tech_links[prer_name] then 
        tech_links[prer_name] = {used_in = {tech_name}}
      else
        if not tech_links[prer_name].used_in then tech_links[prer_name].used_in = {} end
        table.insert (tech_links[prer_name].used_in, tech_name)
      end
    end
  end

  if tech.effects then
    for i, effect in pairs (tech.effects) do
      if effect.type == "unlock-recipe" then
        local recipe_name = effect.recipe
        if not recipes_with_techs[recipe_name] then 
          recipes_with_techs[recipe_name] = {tech_name}
        else
          table.insert (recipes_with_techs[recipe_name], tech_name)
        end
        if not techs_open_recipes[tech_name] then 
          techs_open_recipes[tech_name] = {recipe_name}
        else
          table.insert (techs_open_recipes[tech_name], recipe_name)
        end
      end
    end
  end
end

-- small_serpent (tabl)
log ('recipes_with_techs [' .. table_size(recipes_with_techs) .. ']: ' .. small_serpent (recipes_with_techs))
log ('techs_open_recipes [' .. table_size(techs_open_recipes) .. ']: ' .. small_serpent (techs_open_recipes))

log ('tech_links [' .. table_size(tech_links) .. ']: ' .. small_serpent (tech_links))


function deep_tech_links (tech_link)
  local tech_structure = {}
  if tech_link.used_in then
    for i, tech_name in pairs (tech_link.used_in) do
      local next_tech_link = tech_links[tech_name]
      local deep_structure = deep_tech_links (next_tech_link)
      if deep_structure then 
        tech_structure[tech_name] = deep_structure
      else
        table.insert (tech_structure, tech_name)
      end
    end
  else
    -- tech_structure = nil
  end
  return tech_structure
end

local tech_tree = {}

for tech_name, tech_link in pairs (tech_links) do
  if not tech_link.uses then -- first tech
    tech_tree[tech_name] = deep_tech_links (tech_link)
  end
end

log ('tech_tree [' .. table_size(tech_tree) .. ']: ' .. serpent.block (tech_tree))








































